/**
 *  Hyper Operating System V4 Advance
 *
 * @file  dtqobj.h
 * @brief %jp{f[^L[WFNg̃wb_t@C}%en{Data queue object heder file}
 *
 * Copyright (C) 1998-2009 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#ifndef _KERNEL__object__dtqobj_h__
#define _KERNEL__object__dtqobj_h__



/* ------------------------------------------ */
/*  Primitive type definition                 */
/* ------------------------------------------ */

/* %jp{f[^L[JE^lp̌^} */
#if _KERNEL_DTQCB_BITFIELD		/* %jp{DTQCBɃrbgtB[h𗘗pꍇ} */

#if _KERNEL_OPT_SIGNED_INT && !_KERNEL_OPT_CB_SIZE	/* %jp{tD̏ꍇ1bit₵ĕtg} */
typedef signed int						_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef signed int						_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#define _KERNEL_DTQCB_TBITDEF_DTQCNT	: (_KERNEL_DTQ_TBIT_DTQCNT+1)	/**< %jp{f[^L[JE^̃rbgtB[h錾̕} */
#else
typedef unsigned int					_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef unsigned int					_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#define _KERNEL_DTQCB_TBITDEF_DTQCNT	: _KERNEL_DTQ_TBIT_DTQCNT		/**< %jp{f[^L[JE^̃rbgtB[h錾̕} */
#endif

#else							/* %jp{DTQCBɃrbgtB[h𗘗pȂꍇ} */

#if (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_B) && _KERNEL_OPT_SIGNED_INT
typedef _KERNEL_T_FAST_B				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_B				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_UB) && !(_KERNEL_OPT_SIGNED_INT && !_KERNEL_OPT_CB_SIZE)
typedef _KERNEL_T_FAST_UB				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_UB				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_H) && _KERNEL_OPT_SIGNED_INT
typedef _KERNEL_T_FAST_H				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_H				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_UH) && !(_KERNEL_OPT_SIGNED_INT && !_KERNEL_OPT_CB_SIZE)
typedef _KERNEL_T_FAST_UH				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_UH				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_W) && _KERNEL_OPT_SIGNED_INT
typedef _KERNEL_T_FAST_W				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_W				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_UW) && !(_KERNEL_OPT_SIGNED_INT && !_KERNEL_OPT_CB_SIZE)
typedef _KERNEL_T_FAST_UW				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_UW				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#elif (_KERNEL_DTQ_TMAX_DTQCNT <= _KERNEL_TMAX_D) && _KERNEL_OPT_SIGNED_INT
typedef _KERNEL_T_FAST_D				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_D				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#else
typedef _KERNEL_T_FAST_UD				_KERNEL_DTQ_T_DTQCNT;			/**< %jp{f[^L[JE^Z삷Ƃ̌^} */
typedef _KERNEL_T_LEAST_UD				_KERNEL_DTQCB_T_DTQCNT;			/**< %jp{f[^L[JE^DTQCBɊi[Ƃ̌^} */
#endif
#define _KERNEL_DTQCB_TBITDEF_DTQCNT									/**< %jp{f[^L[JE^̃rbgtB[h錾̕} */

#endif


/* %jp{f[^L[p̌^} */
#if _KERNEL_DTQCB_BITFIELD		/* %jp{DTQCBɃrbgtB[h𗘗pꍇ} */

/* %jp{TA_TFIFO  TA_TPRI ̔ 1bit Kv} */
typedef unsigned int					_KERNEL_DTQ_T_DTQATR;
typedef unsigned int					_KERNEL_DTQCB_T_DTQATR;
#define _KERNEL_DTQCB_TBITDEF_DTQATR	: 1

#else							/* %jp{DTQCBɃrbgtB[h𗘗pȂꍇ} */

typedef _KERNEL_T_FAST_UB				_KERNEL_DTQ_T_DTQATR;
typedef _KERNEL_T_LEAST_UB				_KERNEL_DTQCB_T_DTQATR;
#define _KERNEL_DTQCB_TBITDEF_DTQATR

#endif


/* %jp{f[^L[̈̐擪Ԓnp̌^} */
typedef VP_INT*							_KERNEL_DTQ_T_DTQ;
typedef VP_INT*							_KERNEL_DTQCB_T_DTQ;
#define _KERNEL_DTQCB_TBITDEF_DTQ



/* ------------------------------------------ */
/*  Control block                             */
/* ------------------------------------------ */

#if _KERNEL_DTQCB_SPLIT_RO

/** %jp{f[^L[Rg[ubN([hI[)}%en{Data queue Control Block(read-only)} */
typedef struct _kernel_t_dtqcb_ro
{
#if _KERNEL_DTQCB_DTQATR
	_KERNEL_DTQCB_T_DTQATR	dtqatr		_KERNEL_DTQCB_TBITDEF_DTQATR;		/**< %jp{f[^L[}%en{Data queue attribute} */
#endif

#if _KERNEL_DTQCB_DTQCNT
	_KERNEL_DTQCB_T_DTQCNT	dtqcnt		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[̗̈e(f[^̌)}%en{Capacity of the data queue area(the number of data elements)} */
#endif

#if _KERNEL_DTQCB_DTQ
	_KERNEL_DTQCB_T_DTQ		dtq			_KERNEL_DTQCB_TBITDEF_DTQ;			/**< %jp{f[^L[̈̐擪Ԓn}%en{Start address of the data queue area} */
#endif
} _KERNEL_T_DTQCB_RO;

/** %jp{f[^L[Rg[ubN}%en{Data queue Control Block} */
typedef struct _kernel_t_dtqcb
{
#if _KERNEL_DTQCB_SQUE
	_KERNEL_T_QUE			sque;											/**< %jp{f[^L[M҂^XNL[} */
#endif

#if _KERNEL_DTQCB_RQUE
	_KERNEL_T_QUE			rque;											/**< %jp{f[^L[M҂^XNL[} */
#endif

#if _KERNEL_DTQCB_SDTQCNT
	_KERNEL_DTQCB_T_DTQCNT	sdtqcnt		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[ɓĂf[^̐}%en{The number of data elemnts int the data queue} */
#endif

#if _KERNEL_DTQCB_HEAD
	_KERNEL_DTQCB_T_DTQCNT	head		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[̃f[^擪ʒu} */
#endif


#if _KERNEL_DTQCB_ALGORITHM == _KERNEL_DTQCB_ALG_PTRARRAY
	const _KERNEL_T_SEMCB_RO	*dtqcb_ro;									/**< %jp{f[^L[Rg[ubNROւ̃|C^} */
#endif
} _KERNEL_T_DTQCB;


#else


/** %jp{f[^L[Rg[ubN}%en{Data queue Control Block} */
typedef struct _kernel_t_dtqcb
{
#if _KERNEL_DTQCB_SQUE
	_KERNEL_T_QUE			sque;											/**< %jp{f[^L[M҂^XNL[} */
#endif

#if _KERNEL_DTQCB_RQUE
	_KERNEL_T_QUE			rque;											/**< %jp{f[^L[M҂^XNL[} */
#endif

#if _KERNEL_DTQCB_SDTQCNT
	_KERNEL_DTQCB_T_DTQCNT	sdtqcnt		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[ɓĂf[^̐}%en{The number of data elemnts int the data queue} */
#endif

#if _KERNEL_DTQCB_HEAD
	_KERNEL_DTQCB_T_DTQCNT	head		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[̃f[^擪ʒu} */
#endif


#if _KERNEL_DTQCB_DTQATR
	_KERNEL_DTQCB_T_DTQATR	dtqatr		_KERNEL_DTQCB_TBITDEF_DTQATR;		/**< %jp{f[^L[}%en{Data queue attribute} */
#endif

#if _KERNEL_DTQCB_DTQCNT
	_KERNEL_DTQCB_T_DTQCNT	dtqcnt		_KERNEL_DTQCB_TBITDEF_DTQCNT;		/**< %jp{f[^L[̗̈e(f[^̌)}%en{Capacity of the data queue area(the number of data elements)} */
#endif

#if _KERNEL_DTQCB_DTQ
	_KERNEL_DTQCB_T_DTQ		dtq			_KERNEL_DTQCB_TBITDEF_DTQ;			/**< %jp{f[^L[̈̐擪Ԓn}%en{Start address of the data queue area} */
#endif
} _KERNEL_T_DTQCB;

typedef _KERNEL_T_DTQCB		_KERNEL_T_DTQCB_RO;


#endif



/* ------------------------------------------ */
/*  ID range                                  */
/* ------------------------------------------ */

extern const ID							_kernel_max_dtqid;										/**< %jp{f[^L[ID̍ől} */

#define _KERNEL_DTQ_TMIN_ID				1														/**< %jp{f[^L[ID̍ŏl} */
#define _KERNEL_DTQ_TMAX_ID				(_kernel_max_dtqid)										/**< %jp{f[^L[ID̍ől} */

#define _KERNEL_DTQ_CHECK_DTQID(dtqid)	((dtqid) >= _KERNEL_DTQ_TMIN_ID && (dtqid) <= _KERNEL_DTQ_TMAX_ID)
																								/**< %jp{ID͈̓`FbN} */


/* ------------------------------------------ */
/*  Control block tables                      */
/* ------------------------------------------ */

#if _KERNEL_DTQCB_ALGORITHM == _KERNEL_DTQCB_ALG_BLKARRAY
#if _KERNEL_DTQCB_SPLIT_RO

/* %jp{ubNzǗRȌꍇ}%en{block array} */
extern  _KERNEL_T_DTQCB					_kernel_dtqcb_tbl[];									/**< %jp{f[^L[Rg[ubNe[u} */
extern const _KERNEL_T_DTQCB_RO			_kernel_dtqcb_ro_tbl[];									/**< %jp{f[^L[Rg[ubN([hI[)e[u} */
#define _KERNEL_DTQ_ID2DTQCB(dtqid)		(&_kernel_dtqcb_tbl[(dtqid) - _KERNEL_DTQ_TMIN_ID])		/**< %jp{Rg[ubN̎擾} */
#define _KERNEL_DTQ_CHECK_EXS(dtqid)	(_kernel_dtqcb_ro_tbl[(dtqid) - _KERNEL_DTQ_TMIN_ID].dtq != NULL)
																								/**< %jp{IuWFNg̑݃`FbN} */

#else

/* %jp{ubNzǗ̏ꍇ}%en{block array} */
extern  _KERNEL_T_DTQCB					_kernel_dtqcb_tbl[];									/**< %jp{f[^L[Rg[ubNe[u} */
#define _KERNEL_DTQ_ID2DTQCB(dtqid)		(&_kernel_dtqcb_tbl[(dtqid) - _KERNEL_DTQ_TMIN_ID])		/**< %jp{Rg[ubN̎擾} */
#define _KERNEL_DTQ_CHECK_EXS(dtqid)	(_kernel_dtqcb_tbl[(dtqid) - _KERNEL_DTQ_TMIN_ID].dtq != NULL)
																								/**< %jp{IuWFNg̑݃`FbN} */

#endif

#elif _KERNEL_DTQCB_ALGORITHM == _KERNEL_DTQCB_ALG_PTRARRAY

/* %jp{|C^zǗ̏ꍇ}%en{pointer array} */
extern  _KERNEL_T_DTQCB					*_kernel_dtqcb_tbl[];									/**< %jp{f[^L[Rg[ubNe[u} */
#define _KERNEL_DTQ_ID2DTQCB(dtqid)		(_kernel_dtqcb_tbl[(dtqid) - _KERNEL_DTQ_TMIN_ID])		/**< %jp{f[^L[IDDTQCB AhX擾} */
#define _KERNEL_DTQ_CHECK_EXS(dtqid)	(_KERNEL_DTQ_ID2DTQCB(dtqid) != NULL)					/**< %jp{IuWFNg̑݃`FbN} */

#endif



/* ------------------------------------------ */
/*   Accessor for DTQCB                       */
/* ------------------------------------------ */

/* dtqcb_ro */
#if !_KERNEL_DTQCB_SPLIT_RO								
#define _KERNEL_DTQ_GET_DTQCB_RO(dtqid, dtqcb)	(dtqcb)
#else
#if _KERNEL_DTQCB_ALGORITHM == _KERNEL_DTQCB_ALG_BLKARRAY		/* %jp{DTQCBPzŊǗ}%en{array of block} */
#define _KERNEL_DTQ_GET_DTQCB_RO(dtqid, dtqcb)	(&_kernel_dtqcb_ro_tbl[(dtqid)])
#elif _KERNEL_DTQCB_ALGORITHM == _KERNEL_DTQCB_ALG_PTRARRAY		/* %jp{DTQCB|C^zŊǗ}%en{array of pointer} */
#define _KERNEL_DTQ_GET_DTQCB_RO(dtqid, dtqcb)	((dtqcb)->dtqcb_ro)
#endif
#endif


/* sque */
#define _KERNEL_DTQ_GET_SQUE(dtqcb)			(&(dtqcb)->sque)


/* rque */
#define _KERNEL_DTQ_GET_RQUE(dtqcb)			(&(dtqcb)->rque)


/* sdtqcnt */
#if _KERNEL_DTQCB_SDTQCNT
#define _KERNEL_DTQ_SET_SDTQCNT(dtqcb, x)	do { (dtqcb)->sdtqcnt = (_KERNEL_DTQCB_T_DTQCNT)(x); } while (0)
#define _KERNEL_DTQ_GET_SDTQCNT(dtqcb)		((_KERNEL_DTQ_T_DTQCNT)(dtqcb)->sdtqcnt)
#else
#define _KERNEL_DTQ_SET_SDTQCNT(dtqcb, x)	do { } while (0)
#define _KERNEL_DTQ_GET_SDTQCNT(dtqcb)		(0)
#endif


/* head */
#if _KERNEL_DTQCB_HEAD
#define _KERNEL_DTQ_SET_HEAD(dtqcb, x)		do { (dtqcb)->head = (_KERNEL_DTQCB_T_DTQCNT)(x); } while (0)
#define _KERNEL_DTQ_GET_HEAD(dtqcb)			((_KERNEL_DTQ_T_DTQCNT)(dtqcb)->head)
#else
#define _KERNEL_DTQ_SET_HEAD(dtqcb, x)		do { } while (0)
#define _KERNEL_DTQ_GET_HEAD(dtqcb)			(0)
#endif


/* dtqatr */
#if _KERNEL_DTQCB_DTQATR
#define _KERNEL_DTQ_SET_DTQATR(dtqcb, x)	do { (dtqcb)->dtqatr = (_KERNEL_DTQCB_T_DTQATR)(x); } while (0)
#define _KERNEL_DTQ_GET_DTQATR(dtqcb)		((_KERNEL_DTQ_T_DTQATR)(dtqcb)->dtqatr)
#else
#define _KERNEL_DTQ_SET_DTQATR(dtqcb, x)	do { } while (0)
#if _KERNEL_SPT_DTQ_TA_TFIFO
#define _KERNEL_DTQ_GET_DTQATR(dtqcb)		(TA_TFIFO)
#else
#define _KERNEL_DTQ_GET_DTQATR(dtqcb)		(TA_TPRI)
#endif
#endif


/* dtqcnt */
#if _KERNEL_DTQCB_DTQCNT
#define _KERNEL_DTQ_SET_DTQCNT(dtqcb_ro, x)	do { (dtqcb_ro)->dtqcnt = (_KERNEL_DTQCB_T_DTQCNT)(x); } while (0)
#define _KERNEL_DTQ_GET_DTQCNT(dtqcb_ro)	((_KERNEL_DTQ_T_DTQCNT)(dtqcb_ro)->dtqcnt)
#else
#define _KERNEL_DTQ_SET_DTQCNT(dtqcb_ro, x)	do { } while (0)
#define _KERNEL_DTQ_GET_DTQCNT(dtqcb_ro)	(0)
#endif


/* dtq */
#if _KERNEL_DTQCB_DTQ
#define _KERNEL_DTQ_SET_DTQ(dtqcb_ro, x)	do { (dtqcb_ro)->dtq = (VP_INT *)(x); } while (0)
#define _KERNEL_DTQ_GET_DTQ(dtqcb_ro)		((VP_INT *)(dtqcb_ro)->dtq)
#else
#define _KERNEL_DTQ_SET_DTQ(dtqcb_ro, x)	do { } while (0)
#define _KERNEL_DTQ_GET_DTQ(dtqcb_ro)		(0)
#endif



/* ------------------------------------------ */
/*   Macro functions                          */
/* ------------------------------------------ */

/* %jp{L[ڑ} */
#if _KERNEL_SPT_DTQ_TA_TFIFO && _KERNEL_SPT_DTQ_TA_TPRI		/* %jp{TA_TFIFO  TA_TPRI ̍ } */
#define _KERNEL_DTQ_ADD_SQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADD_QUE(_KERNEL_DTQ_GET_SQUE(dtqcb), tskhdl, _KERNEL_DTQ_GET_DTQATR(dtqcb_ro))
#define _KERNEL_DTQ_ADD_RQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADD_QUE(_KERNEL_DTQ_GET_RQUE(dtqcb), tskhdl, _KERNEL_DTQ_GET_DTQATR(dtqcb_ro))
#elif _KERNEL_SPT_DTQ_TA_TFIFO && !_KERNEL_SPT_SE_TA_TPRI	/* %jp{TA_TFIFO ̂ݗp } */
#define _KERNEL_DTQ_ADD_SQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADF_QUE(_KERNEL_DTQ_GET_SQUE(dtqcb), tskhdl)
#define _KERNEL_DTQ_ADD_RQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADF_QUE(_KERNEL_DTQ_GET_RQUE(dtqcb), tskhdl)
#elif !_KERNEL_SPT_DTQ_TA_TFIFO && _KERNEL_SPT_DTQ_TA_TPRI	/* %jp{TA_TPRI ̂ݗp } */
#define _KERNEL_DTQ_ADD_SQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADP_QUE(_KERNEL_DTQ_GET_SQUE(dtqcb), tskhdl)
#define _KERNEL_DTQ_ADD_RQUE(dtqcb, dtqcb_ro, tskhdl)	_KERNEL_ADP_QUE(_KERNEL_DTQ_GET_RQUE(dtqcb), tskhdl)
#else
#error error:_KERNEL_SPT_DTQ_TA_TPRI and _KERNEL_SPT_DTQ_TA_TFIFO
#endif

/* %jp{L[O} */
#define _KERNEL_DTQ_RMV_SQUE(dtqcb, tskhdl)		_KERNEL_RMV_QUE(_KERNEL_DTQ_GET_SQUE(dtqcb), tskhdl)
#define _KERNEL_DTQ_RMV_RQUE(dtqcb, tskhdl)		_KERNEL_RMV_QUE(_KERNEL_DTQ_GET_RQUE(dtqcb), tskhdl)

/* %jp{L[擪o} */
#define _KERNEL_DTQ_RMH_SQUE(dtqcb)				_KERNEL_RMH_QUE(_KERNEL_DTQ_GET_SQUE(dtqcb))
#define _KERNEL_DTQ_RMH_RQUE(dtqcb)				_KERNEL_RMH_QUE(_KERNEL_DTQ_GET_RQUE(dtqcb))


/* %jp{^CAEgL[} */
#if _KERNEL_SPT_TSND_DTQ	/* %jp{tsnd_dtqT|[g̓^CAEgL[l} */
#define _KERNEL_DTQ_ADD_STOQ(tskhdl, tmout)		_KERNEL_SYS_ADD_TOQ(tskhdl, tmout)
#define _KERNEL_DTQ_RMV_STOQ(tskhdl)			_KERNEL_SYS_RMV_TOQ(tskhdl)
#else
#define _KERNEL_DTQ_ADD_STOQ(tskhdl)			do { } while (0)
#define _KERNEL_DTQ_RMV_STOQ(tskhdl)			do { } while (0)
#endif

#if _KERNEL_SPT_TRCV_DTQ	/* %jp{trcv_dtqT|[g̓^CAEgL[l} */
#define _KERNEL_DTQ_ADD_RTOQ(tskhdl, tmout)		_KERNEL_SYS_ADD_TOQ(tskhdl, tmout)
#define _KERNEL_DTQ_RMV_RTOQ(tskhdl)			_KERNEL_SYS_RMV_TOQ(tskhdl)
#else
#define _KERNEL_DTQ_ADD_RTOQ(tskhdl)			do { } while (0)
#define _KERNEL_DTQ_RMV_RTOQ(tskhdl)			do { } while (0)
#endif



/* ------------------------------------------ */
/*   Functions                                */
/* ------------------------------------------ */

#ifdef __cplusplus
extern "C" {
#endif

ER _kernel_cre_dtq(ID dtqid, const T_CDTQ *pk_cdtq);		/**< %jp{f[^L[}%en{Create Data queue} */
ER _kernel_snd_dtq(ID dtqid, VP_INT data, TMO tmout);		/**< %jp{f[^L[ւ̑M()}%en{Send Data Queue} */
ER _kernel_rcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout);	/**< %jp{f[^L[M()}%en{Receive from Data Queue} */

#ifdef __cplusplus
}
#endif




#endif	/* _KERNEL__object__dtqobj_h__ */


/* end of file */
